local grind_messages = {
	{ bit = "normal", message = "rummages around in.*picking a few choice bits to put in his grinder" },
	{ bit = "hot", message = "grabs a bit of.*squealing something about burning" },
	{ bit = "cold", message = "shivers as he rummages for grindable organs, muttering" },
	{ bit = "spooky", message = "shudders as he plunders.*for organs to grind, chattering" },
	{ bit = "stench", message = "holds his nose.*picks some organs" },
	{ bit = "sleaze", message = "blushes a little as he rummages in.*for organs to grind" },
	{ bit = "fish", message = "squelches around in.*for some grinder fodder, muttering" },
	{ bit = "boss", message = "Blimey.*harvests a few choice bits for his grinder." },
}

add_processor("familiar message: organgoblin", function()
	for _, x in pairs(grind_messages) do
		if text:match(x.message) then
			print("organ grinding", x.bit)
			increase_daily_counter("familiar.organ grinder.bits")
			local tbl = get_day_state("familiar.organ grinder.bit types")
			if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
			tbl[x.bit] = true
			set_day_state("familiar.organ grinder.bit types", table_to_str(tbl))
		end
	end

	local pie = text:match("You acquire an item: <b>(.-)</b>")
	if pie then
		increase_daily_counter("familiar.organ grinder.pies")
		set_day_state("familiar.organ grinder.bits", 0)
		set_day_state("familiar.organ grinder.bit types", table_to_str({}))
		print("got a pie", pie)
	end
end)

add_printer("/charpane.php", function()
	if (familiar_picture == "organgoblin") then
		local bits = get_daily_counter("familiar.organ grinder.bits")
		local pies = get_daily_counter("familiar.organ grinder.pies")
		local needbits = "?"
		if pies <= 6 then
			local amounts = { 5, 10, 16, 23, 31, 40, 50 }
			needbits = amounts[pies + 1]
		else
			needbits = 50
		end
		local tbl = get_day_state("familiar.organ grinder.bit types")
		if (tbl == "") then tbl = {} else tbl = str_to_table(tbl) end
		types = ""
		if tbl.fish then
			types = "shoo-fish pie"
		elseif tbl.boss then
			types = "badass pie"
		else
			local element_list = {}
			for _, x in pairs(grind_messages) do
				if tbl[x.bit] and x.bit ~= "normal" then
					table.insert(element_list, x.bit)
				end
			end
			if table.maxn(element_list) > 0 then
				types = table.concat(element_list, ", ")
			else
				types = "liver and let pie"
			end
		end

		compact = string.format([[<span title="%s">%d / %d</span>]], types, bits, needbits)
		normal = bits .. " / " .. needbits .. " bits"

		print_familiar_counter(compact, normal)
	end
end)
