dofile("scripts/base/util.lua")

-- check for valid pwd!

text = nil
url = nil

if can_read_state() ~= "yes" then
	return
end

if not params then
	print("error, params is", params)
	print("path", path)
end

input_params = params
params = parse_params(params)

function setup_functions(skip_refreshing)
	inventory = nil
	status = nil
	buffslist = nil
	function refresh()
		status = str_to_table(get_status_info())
		buffslist = {}
		local effects = str_to_table(status.effects)
		for _, x in pairs(effects) do
			buffslist[x[1]] = tonumber(x[2])
		end
	end
	function refresh_inv()
		inventory = str_to_table(get_inventory_counts())
	end

--~ function level() return tonumber(status.level) end -- doesn't work because CDM moyered it
	function level()
		if basemainstat() < 4 then
			return 1
		else
			return 1 + math.floor(math.sqrt(basemainstat() - 4))
		end
	end

	function have(name)
		return inventory[get_itemid(name)]
	end

	function meat() return tonumber(status.meat) end
	function hp() return tonumber(status.hp) end
	function mp() return tonumber(status.mp) end
	function maxhp() return tonumber(status.maxhp) end
	function maxmp() return tonumber(status.maxmp) end
	function turnsthisrun() return tonumber(status.turnsthisrun) end
	function familiarid() return tonumber(status.familiar) end
	function buff(name) return buffslist[name] end
	function buffturns(name) return buffslist[name] or 0 end
	function advs() return tonumber(status.adventures) end
	function basemuscle() return tonumber(status.basemuscle) end
	function basemysticality() return tonumber(status.basemysticality) end
	function basemoxie() return tonumber(status.basemoxie) end
	function buffedmainstat() return tonumber(status[string.lower(get_mainstat())]) end
	function basemainstat() return tonumber(status["base" .. string.lower(get_mainstat())]) end
	function equipment() return str_to_table(status.equipment) end

	function count(name)
		return inventory[get_itemid(name)] or 0
	end

	function use_item(name, amount)
		return use_itemid(get_itemid(name), amount)
	end

	function equip_item(name, slot)
		return equip_itemid(get_itemid(name), slot)
	end

	function plunge_items(a, b)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return post_page("/knoll.php", { action = "combine", pwd = pwd, item1 = tostring(get_itemid(a)), item2 = tostring(get_itemid(b)), quantity = "1", ajax = "1" })
	end

	function equip_itemid(id, slot)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		local tbl = { pwd = pwd, action = "equip", whichitem = tostring(id), ajax = "1" }
		if slot then
			tbl.slot = tostring(slot)
		end
		return get_page("/inv_equip.php", tbl)
	end

	function unequip_slot(name)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		return get_page("/inv_equip.php", { pwd = pwd, action = "unequip", type = name, ajax = "1" })
	end

	function use_itemid(id, amount)
		local pwd = get_session_state("pwd") -- inserting pwd, boo!
		if amount then
			return get_page("/multiuse.php", { pwd = pwd, whichitem = tostring(id), ajax = "1", quantity = tostring(amount), action = "useitem" })
		else
			return get_page("/inv_use.php", { pwd = pwd, whichitem = tostring(id), ajax = "1" })
		end
	end

	function switch_familiarid(id)
		return get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(id) })
	end

	local function handle_adv_result(pt, url, zoneid, macro, noncombatchoices, specialnoncombatfunction)
		if url:match("/fight.php") and url:match("ireallymeanit") then
			local advagain = nil
			if pt:match([[>You win the fight!<!%-%-WINWINWIN%-%-><]]) then
				advagain = true
			elseif pt:match([[state['fightover'] = true;]]) then
				if pt:match("You lose.") then
					advagain = false
				elseif pt:match([[<a href="adventure.php%?snarfblat=]]..zoneid..[[">Adventure Again]]) then
					advagain = true
				end
			end
			if advagain == nil and macro then
				local pt, url = post_page("/fight.php", { action = "macro", macrotext = macro })
				return handle_adv_result(pt, url, zoneid, nil, noncombatchoices, specialnoncombatfunction)
			elseif advagain ~= nil then
				return pt, url, advagain
			else
				print("url", url)
				return pt, url
			end
		elseif url:match("/choice.php") then
			local adventure_title = pt:match([[<tr><td style="color: white;" align=center bgcolor=blue><b>([^<]*)</b></td></tr>]])
			if adventure_title == "Results:" then
				if pt:match([[<a href="adventure.php%?snarfblat=]]..zoneid..[[">Adventure Again]]) then
					advagain = true
				end
				return pt, url, advagain
			end
			local choice_adventure_number = tonumber(pt:match([[<input type=hidden name=whichchoice value=([0-9]+)>]]))
	--~ 		print("choice", adventure_title, choice_adventure_number)
			local pickchoice = nil
			local optname = nil
			if specialnoncombatfunction then
				optname, pickchoice = specialnoncombatfunction(adventure_title, choice_adventure_number)
			else
				optname = noncombatchoices[adventure_title]
			end
			if optname and not pickchoice then
				for nr, title in pt:gmatch([[<input type=hidden name=option value=([0-9])><input class=button type=submit value="([^>]+)">]]) do
		--~ 			print("opt", nr, title)
					if title == optname then
						pickchoice = tonumber(nr)
					end
				end
			end
			if pickchoice then
				local pwd = get_session_state("pwd") -- inserting pwd, boo!
				local pt, url = post_page("/choice.php", { pwd = pwd, whichchoice = tostring(choice_adventure_number), option = tostring(pickchoice) })
				return handle_adv_result(pt, url, zoneid, macro, noncombatchoices, specialnoncombatfunction)
			else
				print("choice", adventure_title, choice_adventure_number)
				for nr, title in pt:gmatch([[<input type=hidden name=option value=([0-9])><input class=button type=submit value="([^>]+)">]]) do
					print("opt", nr, title)
				end
				return pt, url, false
			end
		else
			local advagain = false
			if pt:match([[<a href="adventure.php%?snarfblat=]]..zoneid..[[">Adventure Again]]) then
				advagain = true
			else
				print("url", url)
			end
			return pt, url, advagain
		end
	end

	function autoadventure(zoneid, macro, noncombatchoices, specialnoncombatfunction)
		set_fight_state("zone", zoneid)
		set_ascension_state("adventure.lastzone", zoneid)
		if not noncombatchoices then noncombatchoices = {} end
		local pt, url = post_page("/adventure.php", { snarfblat = tostring(zoneid) })
		return handle_adv_result(pt, url, zoneid, macro, noncombatchoices, specialnoncombatfunction)
	end

	if skip_refreshing ~= true then
		refresh()
		refresh_inv()
	end
end

if path == "/trapper.php" then
	if input_params == "[]" then
		local status = str_to_table(get_status_info())
		get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = "72" }) -- parrot
		text, url = get_page(path)
		get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(status.familiar) })
	end
end

if path == "/lair1.php" then
	if params["action"] == "mirror" then
		pwd = get_session_state("pwd") -- inserting pwd, boo!
		get_page("/inv_equip.php", { action = "unequipall", pwd = pwd })
	end
end

if path == "/lair2.php" then
	if params["action"] == "statues" then
		pwd = get_session_state("pwd") -- inserting pwd, boo!
		setup_functions()
		if not have("makeshift SCUBA gear") then
			post_page("/lair2.php", { prepreaction = "sorcriddle1", answer = "fish" })
			post_page("/lair2.php", { prepreaction = "sorcriddle2", answer = "phish" })
			post_page("/lair2.php", { prepreaction = "sorcriddle3", answer = "fsh" })
			post_page("/knoll.php", { action = "combine", pwd = pwd, item1 = "729", item2 = "731", quantity = "1" }) -- hosed fishbowl
			post_page("/knoll.php", { action = "combine", pwd = pwd, item1 = "730", item2 = "733", quantity = "1" }) -- makeshift scuba gear
		end
		equip_item("makeshift SCUBA gear", 3)
		get_page("/lair2.php", { action = "odor" })

		post_page("/lair2.php", { prepreaction = "sequence", seq1= "up", seq2 = "up", seq3 = "down", seq4 = "down", seq5 = "left", seq6 = "right", seq7 = "left", seq8 = "right", seq9 = "b", seq10 = "a" })

		if not have("stone tablet (Sinister Strumming)") then
			local fam = familiarid()
			switch_familiarid(17) -- star starfish
			equip_item("star sword")
			equip_item("star staff")
			equip_item("star crossbow")
			equip_item("star hat")
			post_page("/lair2.php", { prepreaction = "starcage" })
			switch_familiarid(fam)
		end

		get_page("/inv_equip.php", { action = "unequipall", pwd = pwd })
	end
end

if path == "/lair6.php" then
	if params.place == "1" then
		pwd = get_session_state("pwd") -- inserting pwd, boo!
		setup_functions()
		local weapid = equipment().weapon
		local offhandid = equipment().offhand
		equip_item("huge mirror shard")
		text, url = get_page(path, params)
		if weapid then equip_itemid(weapid) end
		if offhandid then equip_itemid(offhandid) end
	end
end

if path == "/manor3.php" then
	tbl = get_ascension_state("zone.manor.glyphs")
	if tbl == "" then
		get_page("/desc_item.php", { whichitem = "278847834" })
		get_page("/desc_item.php", { whichitem = "163456429" })
		get_page("/desc_item.php", { whichitem = "147519269" })
		get_page("/desc_item.php", { whichitem = "905945394" })
		get_page("/desc_item.php", { whichitem = "289748376" })
		get_page("/desc_item.php", { whichitem = "625138517" })
	end
	tbl = get_ascension_state("zone.manor.wines needed")
	if tbl == "" then
		get_page("/manor3.php", { place = "goblet" })
	end
--~ posting page /manor3.php params: Just [("action","pourwine"),("whichwine","2275")]
--~ posting page /manor3.php params: Just [("action","pourwine"),("whichwine","2273")]
--~ posting page /manor3.php params: Just [("action","pourwine"),("whichwine","2274")]
end

if path == "/cave.php" then
	if params.action == "door4" then
		get_page("/desc_item.php", { whichitem = "776620628" })
		get_page("/desc_item.php", { whichitem = "298163869" })
		get_page("/desc_item.php", { whichitem = "564255755" })
		get_page("/desc_item.php", { whichitem = "411336587" })
		get_page("/desc_item.php", { whichitem = "626990413" })
		get_page("/desc_item.php", { whichitem = "647825911" })
		get_page("/desc_item.php", { whichitem = "153915446" })
		get_page("/desc_item.php", { whichitem = "148513878" })
	end
end

if path == "/custom-mix-drinks" then
--~ 	set_session_state("cached itemids", "")
	local recp = str_to_table(get_recipes())
	local cocktailcrafting_recipes = {}
	local still_recipes = {}
	for a, b in pairs(recp) do
		if b.type == "cocktailcrafting" then
			cocktailcrafting_recipes[a] = str_to_table(b.ingredients)
		end
		if b.type == "still" then
			still_recipes[a] = b.ingredient
		end
	end
	local cached_ids = {}
	local inventory = str_to_table(get_inventory_counts())
	local equipment = str_to_table(str_to_table(get_status_info()).equipment)
	function get_amount_available(name)
		return (inventory[get_itemid(name)] or 0)
	end
	local garnishes = {
		["coconut shell"] = true,
		["little paper umbrella"] = true,
		["magical ice cubes"] = true,
	}
	local hippy_store = {
		herbs = 64,
		grapefruit = 70,
		grapes = 70,
		lemon = 70,
		olive = 70,
		orange = 70,
		strawberry = 70,
		tomato = 70,
	}
	local market_store = {
		["soda water"] = 70,
	}
	local store_price = {}
	for a,b in pairs(market_store) do store_price[a] = b end
	local dreadsack = (equipment.hat == get_itemid("filthy knitted dread sack")) or inventory[get_itemid("filthy knitted dread sack")]
	local corduroys = (equipment.pants == get_itemid("filthy corduroys")) or inventory[get_itemid("filthy corduroys")]
	if dreadsack and corduroys then
		for a,b in pairs(hippy_store) do store_price[a] = b end
	end
	local SHC = { "Neuromancer", "vodka stratocaster", "Mon Tiki", "teqiwila slammer", "Divine", "Gordon Bennett", "gimlet", "yellow brick road", "mandarina colada", "tangarita", "Mae West", "prussian cathouse" }
	local resptext = ""
	for x, name in pairs(SHC) do
		resptext = resptext .. name .. ": " .. table.concat(cocktailcrafting_recipes[name], " + ") .. "<br>"
	end
	local resptext = ""
	local advcock = { "pink pony", "fuzzbump", "slip 'n' slide", "ocean motion", "ducha de oro", "horizontal tango", "roll in the hay", "a little sump'm sump'm", "slap and tickle", "perpendicular hula", "rockin' wagon", "calle de miel", "tropical swill", "fruity girl swill", "blended frozen swill", "bungle in the jungle" }
	function can_make(name)
		local available = get_amount_available(name)
		local craftable = 0
		local craft_steps = {}
		if cocktailcrafting_recipes[name] then
			craftable = 100
			for _, x in pairs(cocktailcrafting_recipes[name]) do
				local num, partsteps = can_make(x)
				for _, y in pairs(partsteps) do table.insert(craft_steps, y) end
				craftable = math.min(craftable, num)
			end
		end
		local buyable = 0
		if store_price[name] then
			buyable = 100
		end
		local steps = {}
		if available > 0 then
			table.insert(steps, "have " .. name .. " (" .. available .. ")")
		elseif buyable > 0 then
			table.insert(steps, "buy " .. name .. " (" .. store_price[name] .. " meat)")
		elseif craftable > 0 then
			for _, y in pairs(craft_steps) do table.insert(steps, y) end
			table.insert(steps, "mix " .. name)
		end
		return available + craftable + buyable, steps
	end
	function handle_recipe(name)
		local txt = ""
		for _, x in pairs(cocktailcrafting_recipes[name]) do
			txt = txt .. x .. " (" .. get_amount_available(x) ..  ")  "
		end
		local amount, steps = can_make(name)
		if amount > 0 then
			local stepstext = ""
			for _, x in pairs(steps) do
				stepstext = stepstext .. "<br><small>&nbsp;&nbsp;" .. x .. "</small>"
			end
			return name .. " {" .. amount .. "}: " .. txt .. stepstext
		else
			return [[<span style="color: gray;">]] .. name .. " {" .. amount .. "}: " .. txt .. [[</span>]]
		end
	end
	for x, name in pairs(advcock) do
		resptext = resptext .. handle_recipe(name) .. "<br>"
	end
	return resptext, url

--~ 	function try_to_create(trg)
--~ 		local buffer = ""
--~ 		for i = 1, indent do
--~ 			buffer = buffer .. "+"
--~ 		end
--~ 		print(buffer .. "+try(" .. trg .. ")")
--~ 		local id = tonumber(str_to_table(get_item_data_by_name(trg)).id)
--~ 		if inventory[id] then -- TODO: not just non-zero, since the same item could be needed multiple times for a recipe!
--~ 			print(buffer .. "=try(" .. trg .. ") 0 0 true")
--~ 			return 0, 0, true
--~ 		end
--~ 		if mix_recipes[trg] then
--~ 			mixes, stills, possible = 0, 0, true
--~ 			for _, x in pairs(mix_recipes[trg]) do
--~ 				indent = indent + 1
--~ 				m, s, p = try_to_create(x)
--~ 				indent = indent - 1
--~ 				mixes = mixes + m
--~ 				stills = stills + s
--~ 				possible = possible and p
--~ 			end
--~ 			print(buffer .. "=try(" .. trg .. ") " .. mixes+1 .. " " .. stills .. " " .. tostring(possible))
--~ 			return mixes, stills, possible
--~ 		end
--~ 		if still_recipes[trg] then
--~ 	--~ 			posting page /guild.php params: Just [("action","stillbooze"),("whichitem","787"),("quantity","1")]
--~ 	--~ 			posting page /guild.php params: Just [("action","stillfruit"),("whichitem","243"),("quantity","1")]
--~ 			indent = indent + 1
--~ 			m, s, p = try_to_create(still_recipes[trg])
--~ 			indent = indent - 1
--~ 			print(buffer .. "=try(" .. trg .. ") " .. m .. " " .. s+1 .. " " .. tostring(p))
--~ 			return m, s + 1, p
--~ 		end
--~ 		return 0, 0, false
--~ 	end
--~ 	for _, x in pairs(targets) do
--~ 		try_to_create(x)
--~ 	end
--~ 	text = resptext
end

if path == "/automate-zone" then
	local zoneid = tonumber(params.id)
	local numtimes = tonumber(params.numtimes)
	if zoneid and numtimes then
		setup_functions(true)
		local autochoices = {
			["Wheel in the Clouds in the Sky, Keep On Turning"] = "Leave the wheel alone",
		}
		while numtimes > 0 do
			numtimes = numtimes - 1
			-- ...prepare, heal up, etc...
			text, url, advagain = autoadventure(zoneid, nil, autochoices)
			-- ...handle result, recurse, etc...
			if not advagain then
				return text, url
			end
		end
		return text, url
	end
end

if path == "/automate-tiles" then
	local function choose(tile)
		return post_page("/tiles.php", { action = "jump", whichtile = tostring(tile) })
	end
	choose(4)
	choose(6)
	choose(3)
	choose(5)
	choose(7)
	choose(6)
	text, url = choose(3)
end

-- 			let inrunoption = case choice of
-- 				21 -> 2 -- not trapped in the wrong body
-- 				46 -> 3 -- fight vampire, maybe doubtful?
-- 				105 -> 1 -- gaze into mirror in bathroom
-- 				108 -> 4 -- walk away from craps
-- 				109 -> 1 -- fight hobo
-- 				110 -> 4 -- introduce them to avantgarde
-- 				113 -> 2 -- fight knob goblin chef
-- 				118 -> 2 -- don't do wounded guard quest
-- 				120 -> 4 -- ennui outta here
-- 				123 -> 2 -- raise your hands in hidden temple
-- 				177 -> 5 -- blackberry cobbler, leave
-- 				402 -> 2 -- don't hold a grudge in bathroom, gain myst
-- 				otherwise -> -1
-- 			let aftercoreoption = case choice of
-- 				9 -> 3 -- leave the wheel alone in the castle
-- 				10 -> 3 -- leave the wheel alone in the castle
-- 				11 -> 3 -- leave the wheel alone in the castle
-- 				12 -> 3 -- leave the wheel alone in the castle
-- 				21 -> -1 -- trapped in the wrong body?
-- 				26 -> 2 -- take the scorched path
-- 				28 -> 2 -- investigate the moist crater for spices
-- 				89 -> 2 -- fight TT knight in the gallery
-- 				90 -> 2 -- watch the dancers in ballroom
-- 				112 -> 2 -- no time for harold's bell
-- 				178 -> 2 -- blow popsicle stand in airship
-- 				182 -> 1 -- fight in the airship
-- 				207 -> 2 -- leave hot door alone in burnbarrel
-- 				213 -> 2 -- leave piping hot in burnbarrel
-- 				214 -> 1 -- kick stuff into the hole in the heap
-- 				216 -> 2 -- begone from the compostal service
-- 				otherwise -> inrunoption



local function plunge_items(a, b)
	local aid = tonumber(str_to_table(get_item_data_by_name(a)).id)
	local bid = tonumber(str_to_table(get_item_data_by_name(b)).id)
	post_page("/knoll.php", { action = "combine", pwd = params.pwd, item1 = tostring(aid), item2 = tostring(bid), quantity = "1", ajax = "1" })
end

if path == "/inv_use.php" then
	for a, b in pairs(params) do
		print("use params:", a, b)
	end
	itemstr = get_item_data_by_id(tonumber(params.whichitem))
	if itemstr then
		item = str_to_table(itemstr)
		for a, b in pairs(item) do
			print("use item:", a, b)
		end
		if item.name == "Degrassi Knoll shopping list" then
			stuff = {}
			stuff["bitchin' meatcar"] = { "meat engine", "dope wheels" }
			stuff["dope wheels"] = { "tires", "sweet rims" }
			stuff["meat engine"] = { "cog and sprocket assembly", "full meat tank" }
			stuff["cog and sprocket assembly"] = { "sprocket assembly", "cog" }
			stuff["sprocket assembly"] = { "spring", "sprocket" }
			stuff["full meat tank"] = { "empty meat tank", "meat stack" }
			can_buy = {}
			can_buy["tires"] = true
			can_buy["cog"] = true
			can_buy["spring"] = true
			can_buy["sprocket"] = true
			can_buy["empty meat tank"] = true
			can_buy["meat stack"] = true
			local inventory = str_to_table(get_inventory_counts())
			function combine_tables(a, b)
				ret = {}
				for x, y in pairs(a) do table.insert(ret, y) end
				for x, y in pairs(b) do table.insert(ret, y) end
				return ret
			end
			function try_to_create(name)
--~ 					print("try_to_create", name)
				local d = str_to_table(get_item_data_by_name(name))
				if inventory[tonumber(d.id)] then
--~ 						print("already have", inventory[tonumber(d.id)])
					return { have = { name }, buy = {}, missing = {}, order = {} }
				end
				if can_buy[name] then
--~ 						print("buying", name)
					return { have = {}, buy = { name }, missing = {}, order = {} }
				end
				if stuff[name] then
--~ 						print(name, "pasting", stuff[name][1], stuff[name][2])
					local a = try_to_create(stuff[name][1])
					local b = try_to_create(stuff[name][2])
					local have = combine_tables(a.have, b.have)
					local buy = combine_tables(a.buy, b.buy)
					local missing = combine_tables(a.missing, b.missing)
					local order = combine_tables(a.order, b.order)
					table.insert(order, { stuff[name][1], stuff[name][2] })
--~ 						print(name, "pasted", printstr(have), printstr(buy), printstr(missing), printstr(order))
					return { have = have, buy = buy, missing = missing, order = order }
				end
--~ 					print("missing", name)
				return { have = {}, buy = {}, missing = { name }, order = {} }
			end
			meatcar = try_to_create("bitchin' meatcar")
--~ 				print("need to buy", printstr(meatcar.buy))
--~ 				print("missing", printstr(meatcar.missing))
			if (meatcar.missing[1]) then
				local missing_list = {}
				for a, b in pairs(meatcar.missing) do table.insert(missing_list, [[<span style="color: orange;">]] .. b .. [[</span>]]) end
				for a, b in pairs(meatcar.buy) do table.insert(missing_list, [[<span style="color: gray;">]] .. b .. [[</span>]]) end
				for a, b in pairs(meatcar.have) do table.insert(missing_list, [[<span style="color: green;">]] .. b .. [[</span>]]) end
				text, url = get_page("/inv_use.php", params):gsub("<blockquote>.+</blockquote>", "<blockquote>Needed items:<p><blockquote><p>" .. table.concat(missing_list, "<br>") .. "</p></blockquote></blockquote>")
			else
				function buy_from_general_store(name)
					local id = tonumber(str_to_table(get_item_data_by_name(name)).id)
					get_page("/store.php", { phash = params.pwd, buying = "1", whichitem = tostring(id), howmany = "1", whichstore = "5", ajax = "1", action = "buyitem" })
				end

				for x, name in pairs(meatcar.buy) do
--~ 						print("buying", name)
					if name == "meat stack" then
						local d = str_to_table(get_item_data_by_name(name))
						get_page("/inventory.php", { quantity = "1", action = "makestuff", pwd = params.pwd, whichitem = tostring(tonumber(d.id)), ajax = "1" })
					else
						buy_from_general_store(name)
					end
				end
				for x, name in pairs(meatcar.order) do
--~ 						print("pasting", name[1], name[2])
					plunge_items(name[1], name[2])
				end

				get_page("/town_right.php", { place = "untinker" })
				get_page("/knoll.php", { place = "smith" })
				get_page("/town_right.php", { place = "untinker" })
				get_page("/guild.php", { place = "paco" }) -- need the topmenu refreshed from this
				text, url = get_page("/inv_use.php", params)
				post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = tostring(tonumber(str_to_table(get_item_data_by_name("bitchin' meatcar")).id)) })
				post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = tostring(tonumber(str_to_table(get_item_data_by_name("dope wheels")).id)) })

				text = "<script>parent.menupane.location.href=parent.menupane.location.href;</script>" .. text -- do in a prettier way?
			end
		end
		if item.name == "black market map" then
			local status = str_to_table(get_status_info())
			plunge_items("broken wings", "sunken eyes")
			local id = tonumber(str_to_table(get_item_data_by_name("reassembled blackbird")).id)
			get_page("/inv_familiar.php", { whichitem = tostring(id), ajax = "1", pwd = params.pwd })
			get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = "59" }) -- blackbird
			text, url = get_page(path, params)
			get_page("/familiar.php", { action = "newfam", ajax = "1", newfam = tostring(status.familiar) })
		end
	end
end

if path == "/mountains.php" then
	if params.orcs == "1" then
		post_page("/town_right.php", { pwd = params.pwd, action = "untinker", whichitem = tostring(tonumber(str_to_table(get_item_data_by_name("abridged dictionary")).id)) })
	end
end

mode = "intercept"
dofile("scripts/ascension.lua")
dofile("scripts/nemesis-automation.lua")
dofile("scripts/ascension-automation.lua")
dofile("scripts/spading-automation.lua")

if text then
	return text, url
else
	return submit_page(request_type, path, params)
end
